#!/bin/sh
out="/dev/null"
if grep -q 'ttyS0' /var/tuxbox/boot/boot.conf; then
	out="/dev/console"
fi

MOUNTDIR=$(grep ^MOUNTDIR=.* /etc/init.d/init_ide | cut -d '=' -f 2)
SD=/dev/mmc/disc0/disc
msg=/tmp/inst.txt
msg1=/tmp/inst1.txt

wait_msgbox ()
{
	while [ 1 ]
	do
	if pidof msgbox > /dev/null; then
	xsleep 500000
	killall msgbox
	break
	fi
	xsleep 500000
	done
}

MSGBOX1 ()
{
echo ~cBitte warten >> $msg1
msgbox refresh=0 size=32 timeout=90 title="none" popup=$msg1
rm $msg1
}

reverse ()
{
	local _line
	while read -r _line ; do
		reverse
		echo "$_line"
		break
	done
}

ideunmount ()
{
sync
reverse < /proc/mounts | \
while read des fs type rest; do
	if [ "`echo "$des" | grep mmc`" = "" ]
	then
		case "$type" in
			nfs)	if [ "$fs" != "/" ]; then
					echo "Unmounting 'nfs' on '$fs'" > $out
					umount -f $fs
				else
					echo "Skipping 'nfs' on '$fs'" > $out
				fi;
			;;

			cifs)	echo "Unmounting 'cifs' on '$fs'" > $out
				umount -f $fs
			;;
			ext2)	echo "Unmounting 'ext2' on '$fs'" > $out
				umount -f $fs
				sleep 3
			;;
			ext3)	echo "Unmounting 'ext3' on '$fs'" > $out
				umount -f $fs
				sleep 3
			;;
			xfs)	echo "Unmounting 'xfs' on '$fs'" > $out
				umount -f $fs
				sleep 3
			;;
		esac
	fi

done
}

mounttest ()
{
if mount | grep 'mmc/disc0' > /dev/null; then
	echo "Unmounte MMC-Karte" > $out
	umount /mmc
	xsleep 500000
	if mount | grep 'mmc/disc0' > /dev/null; then
		echo ~c~FVorgang wurde abgebrochen ! > $msg
		echo ~c~YSD/MMC-Karte ~Skonnte nicht unmountet werden. >> $msg
		echo ~s >> $msg
		echo ~cBitte alle auf Karte laufende Prozesse beenden. >> $msg
		if [ -e /var/etc/.neutrino_mmc -o -e /var/etc/.neutrino_ide ] ; then
			echo ~s >> $msg
			echo ~cDie ~Yausgelagerte Neutrino ~Smu~z in das Image >> $msg
			echo ~czur~uckgespielt werden. >> $msg
			echo ~s >> $msg
			echo ~cDanach erneut versuchen. >> $msg
		fi
		rm /tmp/.msg2
		killall msgbox
		wget -O /dev/null http://localhost/cgi-bin/startPlugin?name=msgbox.cfg >$out
		exit
	fi
fi
}

test_part ()
{
fdisk $SD << EOF
p
EOF

}

case "$1" in

MSGBOX2)
	if [ -e /tmp/.install_mmc ] ;then
		info="~cMMC/SD Karte wird unmountet.~n~s~n~cDabei werden alle auf MMC/SD Karte laufende Prozesse beendet.~n~cDanach kann die gew~unschte Option erneut~n~cdurchgef~uhrt werden.~n~s~n~cBitte warten"
	elif [ -e /tmp/.install_ide ] ;then
		info="~cHDD wird unmountet.~n~s~n~cDabei werden alle auf HDD laufende Prozesse beendet.~n~cDanach kann ~YHDD Setup ~Sbzw. ~YHDD Check ~Serneut~n~cdurchgef~uhrt werden.~n~s~n~cBitte warten"
	elif [ -e /tmp/.unmount_ide ] ;then
		rm /tmp/.msg2
		rm /tmp/.unmount_ide
		info="$msg"
	else
		info="~cMMC/SD Karte wird ~uberpr~uft. Dabei werden~n~calle auf MMC/SD Karte laufende Prozesse beendet~n~cund die Karte unmountet.~n~cDer Test kann bis zu 2 Minuten dauern.~n~s~n~c~YDBOX nach der ~Uberpr~ufung f~ur volle~n~c~YFunktionsf~ahigkeit neu starten.~n~s~n~cMMC/SD Karte wird ~uberpr~uft~n~cBitte warten"
	fi
	if [ -s /tmp/tools.conf ] ;then	
		rm /tmp/.unmount_ide	
		/var/tuxbox/plugins/shellexec /tmp/tools.conf
		rm -r /tmp/tools.conf
		rm -r $msg
	else
		msgbox cyclic=0 refresh=0 size=32 timeout=150 title="none" popup="$info"
	fi
;;

ide)
	# HDD unmounten
	if [ -e /tmp/.install_ide ] ;then
		sleep 1
		if pidof shellexec > /dev/null; then
			killall shellexec
		fi		
		if `ps > /tmp/.pstest && ! grep -q 'MSGBOX2' /tmp/.pstest`;then
			touch /tmp/.msg2
			echo "WGET von ide_mmc" > $out
			wget -O /dev/null http://localhost/cgi-bin/startPlugin?name=msgbox.cfg >$out
		fi
		[ -e /tmp/.pstest ] && rm /tmp/.pstest
		rm /tmp/.install_ide
		echo "Unmounte HDD" > $out
		ideunmount
		if mount | grep 'ide/host0/bus0/target0/lun0' > /dev/null; then
			echo ~c~FVorgang erneut abgebrochen ! > $msg
			echo ~c~YHDD ~Skonnte nicht unmountet werden. >> $msg
			echo ~s >> $msg
			echo ~cBitte alle auf HDD laufende Prozesse beenden. >> $msg		
		else
			echo "HDD erfolgreich unmountet" > $out

# Baue Menue
echo "FONT=/share/fonts/micron_bold.ttf
KILLEPG=2
TIMESERVICE=NONE
HIGHT=420
WIDTH=520
FONTSIZE=20
PAGING=1
LINESPP=12
MENU=_HDD-Tools
COMMENT=HDD wurde erfolgreich unmountet. Gew~unschte Option
COMMENT=kann durch erneutes Aufrufen wiederholt werden.
COMMENT=*
ACTION=&HDD-Setup (Initialisieren/Formatieren),/sbin/init_hdd.sh
DEPENDON=+&HDD-Info,/var/hddtools/hddinfo,/var/hddtools/hddinfo
DEPENDON=+&HDD-Check,/var/hddtools/hddcheck,/var/hddtools/hddcheck
DEPENDON=+&HDD-Temperaturanzeige,/var/hddtools/hddtemp,/var/hddtools/hddtemp
ENDMENU" > /tmp/tools.conf
		
		fi
		touch /tmp/.unmount_ide
		killall msgbox
		wget -O /dev/null http://localhost/cgi-bin/startPlugin?name=msgbox.cfg >$out
	fi
;;

mmc)
	# Karte checken
	if [ -e /tmp/.check_mmc ] ;then
		sleep 1
		if pidof shellexec > /dev/null; then
			killall shellexec
		fi		
		if `ps > /tmp/.pstest && ! grep -q 'MSGBOX2' /tmp/.pstest`;then
			touch /tmp/.msg2
			echo "WGET von ide_mmc" > $out
			wget -O /dev/null http://localhost/cgi-bin/startPlugin?name=msgbox.cfg >$out
		fi
		[ -e /tmp/.pstest ] && rm /tmp/.pstest
		rm /tmp/.check_mmc
		mounttest
		echo "MMC-Karte wird ueberprueft" > $out
		if test_part | grep '82  Linux swap' > /dev/null; then
			part="part2"
		else
			part="part1"
		fi
		/sbin/fsck -a /dev/mmc/disc0/$part > /dev/null
		sleep 1
		echo `/sbin/fsck -a /dev/mmc/disc0/$part` > /tmp/fsck.txt
		sleep 1
		if ! mount | grep 'mmc/disc0' > /dev/null; then
			echo "Mounte MMC-Karte" > $out
			mount /dev/mmc/disc0/$part /mmc
		fi
		if grep -q 'clean,' /tmp/fsck.txt ; then
			echo ~c~Uberpr~ufung abgeschlossen. > $msg
			echo ~c~s >> $msg
			meldung=`cat /tmp/fsck.txt | cut -f 2 -d 'v'`
			echo ~c"$meldung" >> $msg
		else
			echo ~c~YFilesystem oder MMC/SD Karte wahrscheinlich fehlerhaft. > $msg
			echo ~c~YKarte ~uberpr~ufen und evtl. neu partitionieren >> $msg
			echo ~c~Ybzw. formatieren. >> $msg
		fi
		echo ~c~s >> $msg
		echo ~c~YDie DBOX mu~z ~Ff~ur volle Funktionsf~ahigkeit >> $msg
		echo ~c~Yneu gestartet werden. >> $msg
		rm /tmp/fsck.txt
		rm /tmp/.msg2
		/etc/init.d/endprog emu_start
		killall msgbox
		wget -O /dev/null http://localhost/cgi-bin/startPlugin?name=msgbox.cfg >$out
		sectionsdcontrol --nopause
		#/sbin/mmc_utility.sh MSGBOX
	fi

	# Karte unmounten
	if [ -e /tmp/.install_mmc ] ;then
		sleep 1
		if pidof shellexec > /dev/null; then
			killall shellexec
		fi		
		if `ps > /tmp/.pstest && ! grep -q 'MSGBOX2' /tmp/.pstest`;then
			touch /tmp/.msg2
			echo "WGET von ide_mmc" > $out
			wget -O /dev/null http://localhost/cgi-bin/startPlugin?name=msgbox.cfg >$out
		fi
		[ -e /tmp/.pstest ] && rm /tmp/.pstest
		rm /tmp/.install_mmc
		mounttest
		echo "MMC/SD-Karte erfolgreich unmountet" > $out
		echo ~cMMC/SD-Karte wurde erfolgreich unmountet > $msg
		echo ~cGew~unschte Option kann nun wiederholt werden. >> $msg
		rm /tmp/.msg2
		killall msgbox
		wget -O /dev/null http://localhost/cgi-bin/startPlugin?name=msgbox.cfg >$out
		sectionsdcontrol --nopause
	fi
;;
hddcheck)
	wait_umount ()
	{
		while [ 1 ]
		do
		if [ -e /tmp/.ide_fuser ] ;then
			rm -r /tmp/.ide_fuser
			fuser -mk $MOUNTDIR
			sleep 3
			break
		fi
		sleep 1
		done
	}
	wait_umount &
;;
esac

exit 0
